## libcap2 2.66-5ubuntu2.2trisquel1

=== Makefile ===
#
# Makefile for libcap
#
topdir=$(shell pwd)
include Make.Rules

#
# flags
#

all test sudotest install clean: %: %-here
	$(MAKE) -C libcap $@
ifneq ($(PAM_CAP),no)
	$(MAKE) -C pam_cap $@
endif
ifeq ($(GOLANG),yes)
	$(MAKE) -C go $@
	rm -f cap/go.sum
endif
	$(MAKE) -C tests $@
	$(MAKE) -C progs $@
	$(MAKE) -C doc $@

all-here:

test-here:

sudotest-here:

install-here:

clean-here:
	$(LOCALCLEAN)

distclean: clean
	$(DISTCLEAN)
	@echo "CONFIRM Go package cap has right version dependency on cap/psx:"
	for x in $$(find . -name go.mod); do $(BUILD_FGREP) -v "module" $$x | $(BUILD_FGREP) "kernel.org/pub/linux/libs/security/libcap" > /dev/null || continue ; $(BUILD_FGREP) "v$(GOMAJOR).$(VERSION).$(MINOR)" $$x  > /dev/null && continue ; echo "$$x is not updated. Try running: ./gomods.sh v$(GOMAJOR).$(VERSION).$(MINOR)" ; exit 1 ; done
	@echo "ALL go.mod files updated"
	@echo "Confirm headers export current version"
	$(BUILD_FGREP) "#define LIBCAP_MAJOR $(VERSION)" libcap/include/sys/capability.h
	$(BUILD_FGREP) "#define LIBCAP_MINOR $(MINOR)" libcap/include/sys/capability.h
	@echo "Now validate that everything is checked in to a clean tree.."
	test -z "$$(test -x /usr/bin/git && git status --ignored -s)"
	@echo "All good!"

release: distclean
	cd .. && ln -s libcap libcap-$(VERSION).$(MINOR) && tar cvf libcap-$(VERSION).$(MINOR).tar --exclude patches libcap-$(VERSION).$(MINOR)/* && rm libcap-$(VERSION).$(MINOR)

ktest: all
	$(MAKE) -C kdebug test

distcheck: distclean
	./distcheck.sh
	$(MAKE) DYNAMIC=no COPTS="-D_FORTIFY_SOURCE=2 -O1 -g" clean test
	$(MAKE) DYNAMIC=yes clean all test sudotest
	$(MAKE) DYNAMIC=no COPTS="-O2 -std=c89" clean all test sudotest
	$(MAKE) PAM_CAP=no CC=musl-gcc clean all test sudotest
	$(MAKE) CC=clang clean all test sudotest
	$(MAKE) clean all test sudotest
	$(MAKE) distclean

morgangodoc:
	@echo "Now the release is made, you want to remember to run one of:"
	@echo
	@echo "  GOPROXY=https://proxy.golang.org GO111MODULE=on go get kernel.org/pub/linux/libs/security/libcap/cap@v$(GOMAJOR).$(VERSION).$(MINOR)"
	@echo
	@echo or press the request button on this page:
	@echo
	@echo "  https://pkg.go.dev/kernel.org/pub/linux/libs/security/libcap/cap@v$(GOMAJOR).$(VERSION).$(MINOR)"
	@echo
	@echo "This will cause a go.dev documentation update."

morganrelease: distcheck
	@echo "sign the main library tag twice: older DSA key; and newer RSA (kernel.org) key"
	git tag -u D41A6DF2 -s libcap-$(VERSION).$(MINOR) -m "This is libcap-$(VERSION).$(MINOR)"
	git tag -u E2CCF3F4 -s libcap-korg-$(VERSION).$(MINOR) -m "This is libcap-$(VERSION).$(MINOR)"
	@echo "The following are for the Go module tracking."
	git tag -u D41A6DF2 -s v$(GOMAJOR).$(VERSION).$(MINOR) -m "This is the version tag for the 'libcap' Go base directory associated with libcap-$(VERSION).$(MINOR)."
	git tag -u D41A6DF2 -s psx/v$(GOMAJOR).$(VERSION).$(MINOR) -m "This is the (stable) version tag for the 'psx' Go package associated with libcap-$(VERSION).$(MINOR)."
	git tag -u D41A6DF2 -s cap/v$(GOMAJOR).$(VERSION).$(MINOR) -m "This is the (stable) version tag for the 'cap' Go package associated with libcap-$(VERSION).$(MINOR)."
	$(MAKE) release
	@echo "sign the tar file using korg key"
	cd .. && gpg -sba -u E2CCF3F4 libcap-$(VERSION).$(MINOR).tar
	$(MAKE) morgangodoc

=== libcap/Makefile ===
#
# defines
#
topdir=$(shell pwd)/..
include ../Make.Rules
#
# Library version
#
CAPLIBNAME=$(LIBTITLE).so
STACAPLIBNAME=$(LIBTITLE).a
#
PSXTITLE=libpsx
PSXLIBNAME=$(PSXTITLE).so
STAPSXLIBNAME=$(PSXTITLE).a

CAPFILES=cap_alloc cap_proc cap_extint cap_flag cap_text cap_file
CAPMAGICOBJ=cap_magic.o
PSXFILES=../psx/psx
PSXMAGICOBJ=psx_magic.o

# hardening=+all adds this universally, but we don't want this for the lib
CFLAGS  := $(filter-out -fPIE,$(CFLAGS))
LDFLAGS := $(filter-out -fPIE,$(filter-out -pie,$(LDFLAGS)))

# Always build libcap sources this way:
CFLAGS += -fPIC

# The linker magic needed to build a dynamic library as independently
# executable
MAGIC=-Wl,-e,__so_start

INCLS=libcap.h cap_names.h $(INCS)
GPERF_OUTPUT = _caps_output.gperf

CAPOBJS=$(addsuffix .o, $(CAPFILES))
MAJCAPLIBNAME=$(CAPLIBNAME).$(VERSION)
MINCAPLIBNAME=$(MAJCAPLIBNAME).$(MINOR)

PSXOBJS=$(addsuffix .o, $(PSXFILES))
MAJPSXLIBNAME=$(PSXLIBNAME).$(VERSION)
MINPSXLIBNAME=$(MAJPSXLIBNAME).$(MINOR)

all: pcs $(STACAPLIBNAME)
ifeq ($(SHARED),yes)
	$(MAKE) $(CAPLIBNAME)
endif
ifeq ($(PTHREADS),yes)
	$(MAKE) $(STAPSXLIBNAME)
ifeq ($(SHARED),yes)
	$(MAKE) $(PSXLIBNAME)
endif
endif

pcs: $(LIBTITLE).pc
ifeq ($(PTHREADS),yes)
	$(MAKE) $(PSXTITLE).pc
endif

ifeq ($(USE_GPERF),yes)
USE_GPERF_OUTPUT = $(GPERF_OUTPUT)
INCLUDE_GPERF_OUTPUT = -DINCLUDE_GPERF_OUTPUT='"$(GPERF_OUTPUT)"'
endif

$(LIBTITLE).pc: $(LIBTITLE).pc.in
	$(BUILD_SED) -e 's,@prefix@,$(prefix),' \
		-e 's,@exec_prefix@,$(exec_prefix),' \
		-e 's,@libdir@,$(LIBDIR),' \
		-e 's,@includedir@,$(inc_prefix)/include,' \
		-e 's,@VERSION@,$(VERSION).$(MINOR),' \
		-e 's,@deps@,$(DEPS),' \
		$< >$@

$(PSXTITLE).pc: $(PSXTITLE).pc.in
	$(BUILD_SED) -e 's,@prefix@,$(prefix),' \
		-e 's,@exec_prefix@,$(exec_prefix),' \
		-e 's,@libdir@,$(LIBDIR),' \
		-e 's,@includedir@,$(inc_prefix)/include,' \
		-e 's,@VERSION@,$(VERSION).$(MINOR),' \
		-e 's,@deps@,$(DEPS),' \
		$< >$@

_makenames: _makenames.c cap_names.list.h
	$(BUILD_CC) $(BUILD_CFLAGS) $(BUILD_CPPFLAGS) $< -o $@

cap_names.h: _makenames
	./_makenames > cap_names.h

$(GPERF_OUTPUT): cap_names.list.h cap_names.header Makefile
	(cat cap_names.header ; $(BUILD_SED) -e 's/[\{\}"]//g' -e 's/,$$//' cap_names.list.h) | gperf --ignore-case --language=ANSI-C --readonly --null-strings --global-table --hash-function-name=__cap_hash_name --lookup-function-name="__cap_lookup_name" -c -t -m20 $(INDENT) > $@
	$(BUILD_SED) -e 's/unsigned int len/size_t len/' -i $@

# Intention is that libcap keeps up with torvalds' tree, as reflected
# by this maintained version of the kernel header. libcap dynamically
# trims the meaning of "all" capabilities down to that of the running
# kernel as of 2.30. That is, all production kernels should be equal
# to or behind libcap.
#
# Note "./libcap.so --summary" should explain how the built libcap.so
# compares to the running kernel.
UAPI_HEADER := $(topdir)/libcap/include/uapi/linux/capability.h
cap_names.list.h: Makefile $(UAPI_HEADER)
	@echo "=> making $@ from $(UAPI_HEADER)"
	$(BUILD_EGREP) '^#define\s+CAP_([^\s]+)\s+[0-9]+\s*$$' include/uapi/linux/capability.h | $(BUILD_SED) -e 's/^#define\s\+/{"/' -e 's/\s*$$/},/' -e 's/\s\+/",/' -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/' > $@

$(STACAPLIBNAME): $(CAPOBJS)
	$(AR) rcs $@ $^
	$(RANLIB) $@

$(STAPSXLIBNAME): $(PSXOBJS) include/sys/psx_syscall.h
	$(AR) rcs $@ $(PSXOBJS)
	$(RANLIB) $@

ifeq ($(SHARED),yes)

empty: empty.c
	$(CC) -o $@ $<

loader.txt: empty
	$(OBJCOPY) --dump-section .interp=$@ $< /dev/null

cap_magic.o: execable.h execable.c loader.txt libcap.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -DLIBRARY_VERSION=\"$(LIBTITLE)-$(VERSION).$(MINOR)\" -DSHARED_LOADER=\"$(shell cat loader.txt)\" -include ./libcap.h -c execable.c -o $@

$(CAPLIBNAME) $(MAJCAPLIBNAME) $(MINCAPLIBNAME): $(CAPOBJS) $(CAPMAGICOBJ)
	$(LD) $(CFLAGS) $(LDFLAGS) -Wl,-soname,$(MAJCAPLIBNAME) -o $(MINCAPLIBNAME) $^ $(MAGIC)
	ln -sf $(MINCAPLIBNAME) $(MAJCAPLIBNAME)
	ln -sf $(MAJCAPLIBNAME) $(CAPLIBNAME)

psx_magic.o: execable.h psx_exec.c loader.txt
	$(CC) $(CFLAGS) $(CPPFLAGS) -DLIBRARY_VERSION=\"$(PSXTITLE)-$(VERSION).$(MINOR)\" -DSHARED_LOADER=\"$(shell cat loader.txt)\" -c psx_exec.c -o $@

$(PSXLIBNAME) $(MAJPSXLIBNAME) $(MINPSXLIBNAME): $(PSXOBJS) include/sys/psx_syscall.h $(PSXMAGICOBJ)
	$(LD) $(CFLAGS) $(LDFLAGS) -Wl,-soname,$(MAJPSXLIBNAME) -o $(MINPSXLIBNAME) $(PSXOBJS) $(PSXMAGICOBJ) $(MAGIC) $(PSXLINKFLAGS)
	ln -sf $(MINPSXLIBNAME) $(MAJPSXLIBNAME)
	ln -sf $(MAJPSXLIBNAME) $(PSXLIBNAME)
endif

%.o: %.c $(INCLS)
	$(CC) $(CFLAGS) $(CPPFLAGS) -c $< -o $@

cap_text.o: cap_text.c $(USE_GPERF_OUTPUT) $(INCLS)
	$(CC) $(CFLAGS) $(CPPFLAGS) $(INCLUDE_GPERF_OUTPUT) -c $< -o $@

cap_test: cap_test.c $(INCLS) $(CAPOBJS)
	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) $< $(CAPOBJS) -o $@

libcapsotest: $(CAPLIBNAME)
	./$(CAPLIBNAME)
	./$(CAPLIBNAME) --usage
	./$(CAPLIBNAME) --help
	./$(CAPLIBNAME) --summary

libpsxsotest: $(PSXLIBNAME)
	./$(PSXLIBNAME)

test: cap_test
	./cap_test
ifeq ($(SHARED),yes)
	$(MAKE) libcapsotest
ifeq ($(PTHREADS),yes)
	$(MAKE) libpsxsotest
endif
endif

sudotest:
	@echo no sudotests for libcap

install: install-static
ifeq ($(SHARED),yes)
	$(MAKE) install-shared
endif

install-static: install-static-cap
ifeq ($(PTHREADS),yes)
	$(MAKE) install-static-psx
endif

install-shared: install-shared-cap
ifeq ($(PTHREADS),yes)
	$(MAKE) install-shared-psx
endif

install-cap: install-static-cap
ifeq ($(SHARED),yes)
	$(MAKE) install-shared-cap
endif

install-psx: install-static-psx
ifeq ($(SHARED),yes)
	$(MAKE) install-shared-psx
endif

install-static-cap: install-common-cap $(STACAPLIBNAME)
	install -m 0644 $(STACAPLIBNAME) $(FAKEROOT)$(LIBDIR)/$(STACAPLIBNAME)

install-shared-cap: install-common-cap $(MINCAPLIBNAME)
	install -m 0755 $(MINCAPLIBNAME) $(FAKEROOT)$(LIBDIR)/$(MINCAPLIBNAME)
	ln -sf $(MINCAPLIBNAME) $(FAKEROOT)$(LIBDIR)/$(MAJCAPLIBNAME)
	ln -sf $(MAJCAPLIBNAME) $(FAKEROOT)$(LIBDIR)/$(CAPLIBNAME)
ifeq ($(FAKEROOT),)
	-/sbin/ldconfig
endif

install-static-psx: install-common-psx $(STAPSXLIBNAME)
	install -m 0644 $(STAPSXLIBNAME) $(FAKEROOT)$(LIBDIR)/$(STAPSXLIBNAME)

install-shared-psx: install-common-psx $(MINPSXLIBNAME)
	install -m 0755 $(MINPSXLIBNAME) $(FAKEROOT)$(LIBDIR)/$(MINPSXLIBNAME)
	ln -sf $(MINPSXLIBNAME) $(FAKEROOT)$(LIBDIR)/$(MAJPSXLIBNAME)
	ln -sf $(MAJPSXLIBNAME) $(FAKEROOT)$(LIBDIR)/$(PSXLIBNAME)
ifeq ($(FAKEROOT),)
	-/sbin/ldconfig
endif

install-common-cap: install-common $(LIBTITLE).pc
	install -m 0644 include/sys/capability.h $(FAKEROOT)$(INCDIR)/sys
	install -m 0644 $(LIBTITLE).pc $(FAKEROOT)$(PKGCONFIGDIR)/$(LIBTITLE).pc

include/sys/psx_syscall.h: ../psx/psx_syscall.h
	rm -f $@
	ln -s ../../../psx/psx_syscall.h $@

install-common-psx: install-common $(PSXTITLE).pc include/sys/psx_syscall.h
	install -m 0644 include/sys/psx_syscall.h $(FAKEROOT)$(INCDIR)/sys
	install -m 0644 $(PSXTITLE).pc $(FAKEROOT)$(PKGCONFIGDIR)/$(PSXTITLE).pc

install-common:
	mkdir -p -m 0755 $(FAKEROOT)$(INCDIR)/sys
	mkdir -p -m 0755 $(FAKEROOT)$(PKGCONFIGDIR)
	mkdir -p -m 0755 $(FAKEROOT)$(LIBDIR)

clean:
	$(LOCALCLEAN)
	rm -f $(CAPOBJS) $(CAPLIBNAME)* $(STACAPLIBNAME) $(LIBTITLE).pc
	rm -f $(PSXOBJS) $(PSXLIBNAME)* $(STAPSXLIBNAME) $(PSXTITLE).pc
	rm -f cap_names.h cap_names.list.h _makenames $(GPERF_OUTPUT) cap_test
	rm -f include/sys/psx_syscall.h
	rm -f $(CAPMAGICOBJ) $(PSXMAGICOBJ) empty loader.txt
	cd include/sys && $(LOCALCLEAN)

=== pam_cap/Makefile ===
# simple make file for the pam_cap module

topdir=$(shell pwd)/..
include ../Make.Rules

# hardening=+all adds this universally, but we don't want this for the module
CFLAGS  := $(filter-out -fPIE,$(CFLAGS))
LDFLAGS := $(filter-out -fPIE,$(filter-out -pie,$(LDFLAGS)))

# Always build pam_cap sources this way:
CFLAGS += -fPIC

all: pam_cap.so
	$(MAKE) testlink

install: all
	mkdir -p -m 0755 $(FAKEROOT)$(LIBDIR)/security
	install -m 0755 pam_cap.so $(FAKEROOT)$(LIBDIR)/security

../libcap/loader.txt:
	$(MAKE) -C ../libcap loader.txt

execable.o: execable.c ../libcap/execable.h ../libcap/loader.txt
	$(CC) $(CFLAGS) $(CPPFLAGS) -DLIBCAP_VERSION=\"libcap-$(VERSION).$(MINOR)\" -DSHARED_LOADER=\"$(shell cat ../libcap/loader.txt)\" -c execable.c -o $@

LIBCAP:
	$(MAKE) -C ../libcap all
	touch $@

pam_cap.so: pam_cap.o execable.o pam_cap_linkopts LIBCAP
	cat pam_cap_linkopts | xargs -e $(LD) $(LDFLAGS) -o $@ pam_cap.o execable.o $(LIBCAPLIB)

# Some distributions force link everything at compile time, and don't
# take advantage of libpam's dlopen runtime options to resolve ill
# defined symbols from its own linkage as needed. (As the original
# author of that part of libpam, I consider this force linking
# premature optimization.) We debugged its consequences to pam_cap.so
# as part of:
#
#   https://bugzilla.kernel.org/show_bug.cgi?id=214023
#
# If the current build environment is one of those, or we can't
# reliably prove it isn't, extend the link options for pam_cap.so to
# force linkage against libpam and the gazillion other things libpam
# is linked against...
#
# If you want to force this behavior one way or the other, use the
# make FORCELINKPAM=yes or FORCELINKPAM=no override.
ifeq ($(FORCELINKPAM),yes)
pam_cap_linkopts: Makefile
	echo "-Wl,-e,__so_start -lpam" > $@
else
ifeq ($(FORCELINKPAM),no)
pam_cap_linkopts: Makefile
	echo "-Wl,-e,__so_start" > $@
else
pam_cap_linkopts: lazylink.so
	echo "-Wl,-e,__so_start" > $@
	./lazylink.so || echo "-lpam" >> $@

lazylink.so: lazylink.c ../libcap/execable.h ../libcap/loader.txt
	$(LD) -o $@ $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) lazylink.c -DSHARED_LOADER=\"$(shell cat ../libcap/loader.txt)\" -Wl,-e,__so_start
endif
endif

../libcap/libcap.a:
	$(MAKE) -C ../libcap libcap.a

# Avoid $(LDFLAGS) here to avoid conflicts with --static for a in-tree
# test binary.
test_pam_cap: test_pam_cap.c pam_cap.c ../libcap/libcap.a
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ test_pam_cap.c $(LIBCAPLIB) --static

testlink: test.o pam_cap.o
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $+ -lpam -ldl $(LIBCAPLIB)

test: testlink test_pam_cap pam_cap.so
	./test_pam_cap
	LD_LIBRARY_PATH=../libcap ./pam_cap.so
	LD_LIBRARY_PATH=../libcap ./pam_cap.so --help
	@echo "module can be run as an executable!"

sudotest: test_pam_cap
	$(SUDO) ./test_pam_cap root 0x0 0x0 0x0 config=./capability.conf
	$(SUDO) ./test_pam_cap root 0x0 0x0 0x0 config=./sudotest.conf
	$(SUDO) ./test_pam_cap alpha 0x0 0x0 0x0 config=./capability.conf
	$(SUDO) ./test_pam_cap alpha 0x0 0x1 0x80 config=./sudotest.conf
	$(SUDO) ./test_pam_cap beta 0x0 0x1 0x0 config=./sudotest.conf
	$(SUDO) ./test_pam_cap gamma 0x0 0x0 0x81 config=./sudotest.conf
	$(SUDO) ./test_pam_cap delta 0x41 0x80 0x41 config=./sudotest.conf

clean:
	rm -f *.o *.so testlink lazylink.so test_pam_cap pam_cap_linkopts *~
	rm -f LIBCAP

=== debian/changelog ===
libcap2 (1:2.66-5ubuntu2.2trisquel1) ecne-security; urgency=medium

  * Fetch and build as udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Mon, 24 Feb 2025 17:44:47 +0000

libcap2 (1:2.66-5ubuntu2.2) noble-security; urgency=medium

  * SECURITY UPDATE: incorrect group name handling
    - debian/patches/CVE-2025-1390-1.patch: fix potential configuration
      parsing error in pam_cap/pam_cap.c.
    - debian/patches/CVE-2025-1390-2.patch: add a test for bad group prefix
      in pam_cap/sudotest.conf.
    - CVE-2025-1390

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 20 Feb 2025 10:49:57 -0500

## libcap2 2.73

=== go/Makefile ===
# Building the libcap/{cap.psx} Go packages, and examples.
#
# Note, we use symlinks to construct a go.mod build friendly tree. The
# packages themselves are intended to be (ultimately) found via proxy
# as "kernel.org/pub/linux/libs/security/libcap/cap" and
# "kernel.org/pub/linux/libs/security/libcap/psx". However, to
# validate their use on these paths, we fake such a structure in the
# build tree with symlinks and a vendor directory.

topdir=$(realpath ..)
include $(topdir)/Make.Rules

IMPORTDIR=kernel.org/pub/linux/libs/security/libcap
PKGDIR=pkg/$(GOOSARCH)/$(IMPORTDIR)

DEPS=../libcap/libcap.a ../libcap/libpsx.a
TESTS=compare-cap try-launching psx-signals mismatch

all: PSXGOPACKAGE CAPGOPACKAGE web setid gowns captree captrace

vet: PSXGOPACKAGE CAPGOPACKAGE
	CC="$(CC)" CGO_ENABLED="$(CGO_REQUIRED)" $(GO) vet -mod=vendor kernel.org/pub/linux/libs/security/libcap/cap
	CC="$(CC)" CGO_ENABLED="$(CGO_REQUIRED)" $(GO) vet -mod=vendor kernel.org/pub/linux/libs/security/libcap/psx

$(DEPS):
	$(MAKE) -C ../libcap all

../progs/tcapsh-static:
	$(MAKE) -C ../progs tcapsh-static

vendor/$(IMPORTDIR):
	mkdir -p "vendor/$(IMPORTDIR)"

vendor/modules.txt: vendor/$(IMPORTDIR)
	echo "# $(IMPORTDIR)/psx v$(GOMAJOR).$(VERSION).$(MINOR)" > vendor/modules.txt
	echo "$(IMPORTDIR)/psx" >> vendor/modules.txt
	echo "# $(IMPORTDIR)/cap v$(GOMAJOR).$(VERSION).$(MINOR)" >> vendor/modules.txt
	echo "$(IMPORTDIR)/cap" >> vendor/modules.txt

vendor/$(IMPORTDIR)/psx: vendor/modules.txt
	ln -sf $(topdir)/psx vendor/$(IMPORTDIR)
	touch ../psx

vendor/$(IMPORTDIR)/cap: vendor/modules.txt
	ln -sf $(topdir)/cap vendor/$(IMPORTDIR)
	touch ../cap

$(topdir)/libcap/cap_names.h:
	$(MAKE) -C $(topdir)/libcap cap_names.h

good-names.go: $(topdir)/libcap/cap_names.h vendor/$(IMPORTDIR)/cap mknames.go
	CC="$(CC)" $(GO) run -mod=vendor mknames.go --header=$< --textdir=$(topdir)/doc/values | gofmt > $@ || rm -f $@
	diff -u ../cap/names.go $@

PSXGOPACKAGE: vendor/$(IMPORTDIR)/psx ../psx/*.go $(DEPS)
	touch $@

CAPGOPACKAGE: vendor/$(IMPORTDIR)/cap ../cap/*.go good-names.go $(PSXGOPACKAGE)
	touch $@

# Compiles something with this package to compare it to libcap. This
# tests more when run under sudotest (see ../progs/quicktest.sh for that).
compare-cap: compare-cap.go CAPGOPACKAGE
	CC="$(CC)" CGO_ENABLED="1" CGO_CFLAGS="$(CGO_CFLAGS)" CGO_LDFLAGS="$(CGO_LDFLAGS)" $(GO) build $(GO_BUILD_FLAGS) -mod=vendor $<

web: ../goapps/web/web.go CAPGOPACKAGE
	CC="$(CC)" CGO_ENABLED="$(CGO_REQUIRED)" $(GO) build $(GO_BUILD_FLAGS) -mod=vendor -o $@ $<
ifeq ($(RAISE_GO_FILECAP),yes)
	$(MAKE) -C ../progs setcap
	$(SUDO) ../progs/setcap cap_setpcap,cap_net_bind_service=p web
	@echo "NOTE: RAISED cap_setpcap,cap_net_bind_service ON web binary"
endif

setid: ../goapps/setid/setid.go CAPGOPACKAGE PSXGOPACKAGE
	CC="$(CC)" CGO_ENABLED="$(CGO_REQUIRED)" $(GO) build $(GO_BUILD_FLAGS) -mod=vendor -o $@ $<

gowns: ../goapps/gowns/gowns.go CAPGOPACKAGE
	CC="$(CC)" CGO_ENABLED="$(CGO_REQUIRED)" $(GO) build $(GO_BUILD_FLAGS) -mod=vendor -o $@ $<

captree: ../goapps/captree/captree.go CAPGOPACKAGE
	CC="$(CC)" CGO_ENABLED="$(CGO_REQUIRED)" $(GO) build $(GO_BUILD_FLAGS) -mod=vendor -o $@ $<

captrace: ../goapps/captrace/captrace.go CAPGOPACKAGE
	CC="$(CC)" CGO_ENABLED="$(CGO_REQUIRED)" $(GO) build $(GO_BUILD_FLAGS) -mod=vendor -o $@ $<

ok: ok.go vendor/modules.txt
	CC="$(CC)" CGO_ENABLED="0"  $(GO) build $(GO_BUILD_FLAGS) -mod=vendor $<

try-launching: try-launching.go CAPGOPACKAGE ok
	CC="$(CC)" CGO_ENABLED="$(CGO_REQUIRED)" $(GO) build $(GO_BUILD_FLAGS) -mod=vendor $<
ifeq ($(CGO_REQUIRED),0)
	CC="$(CC)" CGO_ENABLED="1" $(GO) build $(GO_BUILD_FLAGS) -mod=vendor -o $@-cgo $<
endif

# This is a test case developed from the deadlock investigation,
# https://github.com/golang/go/issues/50113 . Note the psx-fd.go code
# works when compiled CGO_ENABLED=1, but deadlocks when compiled
# CGO_ENABLED=0. This is true for go1.16 and go1.17. The go1.18
# release fixed this by rewriting the AllThreadsSyscall support, but
# the large change was not backported. (See noted bug for a much
# smaller patch for this issue on those older releases.)
psx-fd: psx-fd.go PSXGOPACKAGE
	CC="$(CC)" CGO_ENABLED="$(CGO_REQUIRED)" $(GO) build $(GO_BUILD_FLAGS) -mod=vendor -o $@ $<

ifeq ($(CGO_REQUIRED),0)
psx-fd-cgo: psx-fd.go PSXGOPACKAGE
	CC="$(CC)" CGO_ENABLED="1" $(GO) build $(GO_BUILD_FLAGS) -mod=vendor -o $@ $<
endif

psx-signals: psx-signals.go PSXGOPACKAGE
	CC="$(CC)" CGO_ENABLED="$(CGO_REQUIRED)" CGO_CFLAGS="$(CGO_CFLAGS)" CGO_LDFLAGS="$(CGO_LDFLAGS)" $(GO) build $(GO_BUILD_FLAGS) -mod=vendor $<

ifeq ($(CGO_REQUIRED),0)
psx-signals-cgo: psx-signals.go PSXGOPACKAGE
	CC="$(CC)" CGO_ENABLED="1" CGO_CFLAGS="$(CGO_CFLAGS)" CGO_LDFLAGS="$(CGO_LDFLAGS)" $(GO) build $(GO_BUILD_FLAGS) -mod=vendor -o $@ $<
endif

b210613: b210613.go CAPGOPACKAGE
	CC="$(CC)" CGO_ENABLED="$(CGO_REQUIRED)" CGO_CFLAGS="$(CGO_CFLAGS)" CGO_LDFLAGS="$(CGO_LDFLAGS)" $(GO) build $(GO_BUILD_FLAGS) -mod=vendor $<

b215283: b215283.go CAPGOPACKAGE
	CC="$(CC)" CGO_ENABLED="$(CGO_REQUIRED)" CGO_CFLAGS="$(CGO_CFLAGS)" CGO_LDFLAGS="$(CGO_LDFLAGS)" $(GO) build $(GO_BUILD_FLAGS) -mod=vendor $<

ifeq ($(CGO_REQUIRED),0)
b215283-cgo: b215283.go CAPGOPACKAGE
	CC="$(CC)" CGO_ENABLED="1" CGO_CFLAGS="$(CGO_CFLAGS)" CGO_LDFLAGS="$(CGO_LDFLAGS)" $(GO) build $(GO_BUILD_FLAGS) -mod=vendor -o $@ $<
endif

mismatch: mismatch.go PSXGOPACKAGE
	CC="$(CC)" CGO_ENABLED="$(CGO_REQUIRED)" CGO_CFLAGS="$(CGO_CFLAGS)" CGO_LDFLAGS="$(CGO_LDFLAGS)" $(GO) build $(GO_BUILD_FLAGS) -mod=vendor $<

iaber: iaber.go CAPGOPACKAGE PSXGOPACKAGE
	CC="$(CC)" CGO_ENABLED="$(CGO_REQUIRED)" CGO_CFLAGS="$(CGO_CFLAGS)" CGO_LDFLAGS="$(CGO_LDFLAGS)" $(GO) build $(GO_BUILD_FLAGS) -mod=vendor $<

ifeq ($(CGO_REQUIRED),0)
mismatch-cgo: mismatch.go CAPGOPACKAGE
	CC="$(CC)" CGO_ENABLED="1" CGO_CFLAGS="$(CGO_CFLAGS)" CGO_LDFLAGS="$(CGO_LDFLAGS)" $(GO) build $(GO_BUILD_FLAGS) -mod=vendor -o $@ $<
endif

test: vet setid gowns captree psx-fd $(TESTS)
	CC="$(CC)" CGO_ENABLED="$(CGO_REQUIRED)" $(GO) test -v -mod=vendor $(IMPORTDIR)/psx
	CC="$(CC)" CGO_ENABLED="$(CGO_REQUIRED)" $(GO) test -v -mod=vendor $(IMPORTDIR)/cap
	LD_LIBRARY_PATH=../libcap ./compare-cap
	./psx-signals
	./mismatch || exit 0 ; exit 1
	timeout 5 ./psx-fd || echo "this is a known Go bug"
ifeq ($(CGO_REQUIRED),0)
	$(MAKE) psx-signals-cgo mismatch-cgo psx-fd-cgo
	./psx-signals-cgo
	./mismatch-cgo || exit 0 ; exit 1
	./psx-fd-cgo
endif
	./setid --caps=false
	./gowns -- -c "echo gowns runs"
	./captree 0

# Note, the user namespace doesn't require sudo, but I wanted to avoid
# requiring that the hosting kernel supports user namespaces for the
# regular test case.
sudotest: test ../progs/tcapsh-static b210613 b215283 iaber
	../progs/tcapsh-static --has-b=cap_sys_admin || exit 0 && ./gowns --ns -- -c "echo gowns runs with user namespace"
	./try-launching
ifeq ($(CGO_REQUIRED),0)
	./try-launching-cgo
endif
	$(SUDO) ./try-launching
ifeq ($(CGO_REQUIRED),0)
	$(SUDO) ./try-launching-cgo
endif
	$(SUDO) ../progs/tcapsh-static --cap-uid=$$(id -u) --caps="cap_setpcap=ep" --iab="^cap_setpcap" -- -c ./b210613
	$(SUDO) ./b215283
ifeq ($(CGO_REQUIRED),0)
	$(MAKE) b215283-cgo
	$(SUDO) ./b215283-cgo
endif
	@echo should pass:
	$(SUDO) ./iaber '!^cap_setgid,^cap_setuid,^cap_setpcap' '!^cap_setuid,^cap_setgid'
	@echo should fail:
	$(SUDO) ./iaber '!^cap_setgid,^cap_setuid' '!^cap_setuid,^cap_setgid' || exit 0 ; exit 1

# As of libcap-2.55 We stopped installing the cap and psx packages as
# part of the install.  Most distribution's packagers skip the Go
# builds, so it was not well used any way. The new hotness is to just
# use Go modules and download the packages from a tagged release in
# the git repository. For an example of how to do this from scratch:
#
#   https://sites.google.com/site/fullycapable/getting-started-with-go/building-go-programs-that-manipulate-capabilities
#
# For those brave souls that do include the Go build (testing) as part
# of their packaging, we reward them with a copy of the captree
# utility!
install: all
	mkdir -p -m 0755 $(FAKEROOT)$(SBINDIR)
	install -m 0755 captree $(FAKEROOT)$(SBINDIR)

clean:
	rm -f *.o *.so *~ mknames ok good-names.go
	rm -f web setid gowns captree captrace iaber
	rm -f compare-cap try-launching try-launching-cgo
	rm -f $(topdir)/cap/*~ $(topdir)/psx/*~
	rm -f b210613 b215283 b215283-cgo psx-signals psx-signals-cgo
	rm -f mismatch mismatch-cgo psx-fd psx-fd-cgo
	rm -fr vendor CAPGOPACKAGE PSXGOPACKAGE go.sum

=== libcap/Makefile ===
--- 
+++ 
@@ -13,17 +13,17 @@
 PSXLIBNAME=$(PSXTITLE).so
 STAPSXLIBNAME=$(PSXTITLE).a
 
-CAPFILES=cap_alloc cap_proc cap_extint cap_flag cap_text cap_file
+CAPFILES=cap_alloc cap_proc cap_extint cap_flag cap_text cap_file cap_syscalls
 CAPMAGICOBJ=cap_magic.o
-PSXFILES=../psx/psx
+PSXFILES=../psx/psx ../psx/wrap/psx_wrap
 PSXMAGICOBJ=psx_magic.o
 
-# hardening=+all adds this universally, but we don't want this for the lib
-CFLAGS  := $(filter-out -fPIE,$(CFLAGS))
-LDFLAGS := $(filter-out -fPIE,$(filter-out -pie,$(LDFLAGS)))
-
 # Always build libcap sources this way:
-CFLAGS += -fPIC
+CFLAGS += -fPIC -D_LIBPSX_PTHREAD_LINKAGE
+
+# https://bugzilla.kernel.org/show_bug.cgi?id=219168
+OVERRIDE_BSYMBOLIC_FUNCTIONS := -Wl,-Bsymbolic-functions
+LDFLAGS := $(filter-out $(OVERRIDE_BSYMBOLIC_FUNCTIONS),$(LDFLAGS))
 
 # The linker magic needed to build a dynamic library as independently
 # executable
@@ -113,7 +113,7 @@
 ifeq ($(SHARED),yes)
 
 empty: empty.c
-	$(CC) -o $@ $<
+	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) $< -o $@
 
 loader.txt: empty
 	$(OBJCOPY) --dump-section .interp=$@ $< /dev/null

=== debian/changelog ===
libcap2 (1:2.73-4ubuntu1) plucky; urgency=medium

  * Merge with Debian Unstable. Remaining changes:
    - Strip -Wl,-Bsymbolic-functions from LDFLAGS (LP: #2003892)
    - d/t/upstream-root: Skip "uns_test" to fix autopkgtests on armhf.
      It's failing on armhf due to the version of the kernel we use in our
      infrastructure for for this architecture. Once we upgrade our hosts,
      this patch can be dropped. See LP: #2003892.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Thu, 20 Feb 2025 14:00:25 -0600

libcap2 (1:2.73-4) unstable; urgency=medium

  * Cherry-pick patch fixing CVE-2025-1390.
    In /etc/security/capability.conf, configurations not starting with "@"
    were incorrectly recognized as group names. (Closes: #1098318)
  * Fix bug number in previous changelog entry

 -- Christian Kastner <ckk@debian.org>  Wed, 19 Feb 2025 23:17:43 +0100

libcap2 (1:2.73-3) unstable; urgency=medium

  [ Christian Kastner ]
  * libcap2-bin.install: Skip pam_cap.8
    As upstream also ships this file now, installing all of man8 also
    installed pam_cap.8, whereas we were shipping our own version in
    libpam-cap. Our own version was dropped, and libpam-cap will ship
    upstream's version instead. (Closes: #1096207, #1098209)
  * Bump Standards-Version to 4.7.0 (no changes needed)

  [ Otto Kekäläinen ]
  * Enable Salsa CI using default template.
    Keep BLHC disabled so that the pipeline can pass. The purpose it so catch
    regressions, so the pipeline should be green on mainline.

 -- Christian Kastner <ckk@debian.org>  Mon, 17 Feb 2025 21:52:02 +0100

libcap2 (1:2.73-2) unstable; urgency=medium

  * symbols: Drop accidentally included Debian revision

 -- Christian Kastner <ckk@debian.org>  Mon, 17 Feb 2025 11:02:53 +0100

libcap2 (1:2.73-1) unstable; urgency=medium

  * New upstream version 2.73
    - Refresh patches
  * Use capability.conf.5 now provided by upstream
  * Update symbols file
    This drops internal symbols but also one symbol that was exported, but
    clearly not intended to be.
  * d/rules: Undo file change in clean step.
    Resolves a FTBFS twice in a row.

 -- Christian Kastner <ckk@debian.org>  Mon, 17 Feb 2025 10:46:10 +0100

=== debian/control ===
Source: libcap2
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Christian Kastner <ckk@debian.org>
Build-Depends: chrpath,
               debhelper-compat (= 13),
               gperf (>= 3.1),
               indent,
               libpam0g-dev,
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://sites.google.com/site/fullycapable/
Vcs-Git: https://salsa.debian.org/debian/libcap2.git
Vcs-Browser: https://salsa.debian.org/debian/libcap2

Package: libcap2-bin
Section: utils
Priority: important
Architecture: linux-any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libcap-bin
Replaces: libcap-bin
Recommends: libpam-cap
Description: POSIX 1003.1e capabilities (utilities)
 Libcap implements the user-space interfaces to the POSIX 1003.1e capabilities
 available in Linux kernels. These capabilities are a partitioning of the all
 powerful root privilege into a set of distinct privileges.
 .
 This package contains additional utilities.

Package: libcap2
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: POSIX 1003.1e capabilities (library)
 Libcap implements the user-space interfaces to the POSIX 1003.1e capabilities
 available in Linux kernels. These capabilities are a partitioning of the all
 powerful root privilege into a set of distinct privileges.
 .
 This package contains the shared library.

Package: libcap-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libcap2 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Suggests: manpages-dev
Provides: libcap2-dev
Description: POSIX 1003.1e capabilities (development)
 Libcap implements the user-space interfaces to the POSIX 1003.1e capabilities
 available in Linux kernels. These capabilities are a partitioning of the all
 powerful root privilege into a set of distinct privileges.
 .
 This package contains the development files.

Package: libpam-cap
Section: admin
Architecture: linux-any
Multi-Arch: same
Depends: libpam-runtime (>= 1.1.3-2~), ${misc:Depends}, ${shlibs:Depends}
Breaks: libcap2-bin (<< 1:2.66-1)
Replaces: libcap2-bin (<< 1:2.66-1)
Description: POSIX 1003.1e capabilities (PAM module)
 Libcap implements the user-space interfaces to the POSIX 1003.1e capabilities
 available in Linux kernels. These capabilities are a partitioning of the all
 powerful root privilege into a set of distinct privileges.
 .
 This package contains the PAM module for enforcing capabilities on users and
 groups at PAM session start time.

Package: libcap2-udeb
Section: debian-installer
Architecture: linux-any
Package-Type: udeb
Build-Profiles: <!noudeb>
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: POSIX 1003.1e capabilities (library)
 Libcap implements the user-space interfaces to the POSIX 1003.1e capabilities
 available in Linux kernels. These capabilities are a partitioning of the all
 powerful root privilege into a set of distinct privileges.
 .
 This is a minimal version, only for use in the installation system.

=== debian/rules ===
#!/usr/bin/make -f

# Exports DEB_{BUILD,HOST}_* flags
include /usr/share/dpkg/architecture.mk

# Pass this as version-info to dh_makeshlibs
SHLIBS_MINVER = 1:2.63

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Removing the linker flag. It causes problems with libcap2, see LP#2003892
export DEB_LDFLAGS_MAINT_STRIP = -Wl,-Bsymbolic-functions

# Support cross-compiling
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
CC := $(DEB_HOST_GNU_TYPE)-gcc
endif

# One upstream target, "_makenames", requires the BUILD compiler instead of HOST
BUILD_CC ?= cc
export BUILD_LDFLAGS = $(shell dpkg-architecture -a$(DEB_BUILD_ARCH) -c dpkg-buildflags --get LDFLAGS)
export BUILD_CPPFLAGS = $(shell dpkg-architecture -a$(DEB_BUILD_ARCH) -c dpkg-buildflags --get CPPFLAGS)

# Upstream's way of setting optimization
ifneq (,$(filter noopt, $(DEB_BUILD_OPTIONS)))
COPTS = COPTS=-O0
endif

# See pam_cap/Makefile for FORCELINKPAM
MAKE_ASSIGNMENTS = \
	prefix=/usr \
	FORCELINKPAM=yes \
	GOLANG=no

%:
	dh ${@}


override_dh_auto_clean:
	dh_auto_clean -- $(MAKE_ASSIGNMENTS)
	# Undo change of lookup (see override_dh_auto_build)
	sed -i -e 's,\./tcapsh-static,../progs/tcapsh-static,g' tests/libcap_launch_test.c


override_dh_auto_build:
	# See pam_cap/Makefile for FORCELINKPAM
	dh_auto_build -- \
		$(MAKE_ASSIGNMENTS) \
		BUILD_CC=$(BUILD_CC) \
		CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)- \
		$(COPTS) \
		DYNAMIC=yes \
		SUDO=$(DEB_GAIN_ROOT_CMD)
	# Some of test suite is only invoked when run as real root. Explicitly
	# build all binaries so we can include them in the autopkgtest.	
	dh_auto_build -D libcap -- $(MAKE_ASSIGNMENTS) cap_test
	dh_auto_build -D pam_cap -- $(MAKE_ASSIGNMENTS) test_pam_cap
	# Change lookup from sibling dir to current dir
	sed -i -e 's,\.\./progs/tcapsh-static,./tcapsh-static,g' tests/libcap_launch_test.c
	dh_auto_build -D tests -- $(MAKE_ASSIGNMENTS) \
		psx_test \
		libcap_psx_test \
		uns_test \
		libcap_launch_test \
		libcap_psx_launch_test \
		noop \
		exploit \
		noexploit
	dh_auto_build -D progs -- $(MAKE_ASSIGNMENTS) tcapsh-static


override_dh_installdirs:
	dh_installdirs
	# While the PAM module and the library are in /lib, according to the
	# FHS, development files must go into usr/lib/<triplet>.
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)


override_dh_auto_install:
	# Unfortunately, RPATH seems to be needed for the build-time tests
	# (avoiding it and going through LD_LIBRARY_PATH didn't work in all
	# cases)
	# List is identical to build above, minus noop (no RPATH)
	cd tests && chrpath -d \
		psx_test \
		libcap_psx_test \
		uns_test \
		libcap_launch_test \
		libcap_psx_launch_test \
		exploit \
		noexploit
	dh_auto_install -- \
		$(MAKE_ASSIGNMENTS) \
		lib=lib/$(DEB_HOST_MULTIARCH) \
		PKGCONFIGDIR=/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
		RAISE_SETFCAP=no


override_dh_auto_test:
	dh_auto_test -- $(MAKE_ASSIGNMENTS)


override_dh_makeshlibs:
	dh_makeshlibs -V'libcap2 (>= $(SHLIBS_MINVER))' -plibcap2 \
		--add-udeb=libcap2-udeb -- -c4
	dh_makeshlibs --remaining-packages -- -c4

## libcap2 2.75

=== Makefile ===
#
# Makefile for libcap
#
topdir=$(shell pwd)
include Make.Rules

#
# flags
#

all test sudotest install clean: %: %-here
	$(MAKE) -C libcap $@
ifneq ($(PAM_CAP),no)
	$(MAKE) -C pam_cap $@
endif
ifeq ($(GOLANG),yes)
	$(MAKE) -C go $@
	rm -f cap/go.sum
endif
	$(MAKE) -C tests $@
	$(MAKE) -C progs $@
	$(MAKE) -C doc $@

all-here:

test-here:

sudotest-here:

install-here:

clean-here:
	$(LOCALCLEAN)

gomods-update:
	./gomods.sh v$(GOMAJOR).$(VERSION).$(MINOR)

distclean: clean
	$(DISTCLEAN)
	@echo "CONFIRM Go package cap has right version dependency on cap/psx:"
	for x in $$(find . -name go.mod); do $(BUILD_FGREP) -v "module" $$x | $(BUILD_FGREP) "kernel.org/pub/linux/libs/security/libcap" > /dev/null || continue ; $(BUILD_FGREP) "v$(GOMAJOR).$(VERSION).$(MINOR)" $$x  > /dev/null && continue ; echo "$$x is not updated. Try running: make gomods-update" ; exit 1 ; done
	@echo "ALL go.mod files updated"
	@echo "Confirm headers export current version"
	$(BUILD_FGREP) "#define LIBCAP_MAJOR $(VERSION)" libcap/include/sys/capability.h
	$(BUILD_FGREP) "#define LIBCAP_MINOR $(MINOR)" libcap/include/sys/capability.h
	$(BUILD_FGREP) "#define LIBPSX_MAJOR $(VERSION)" psx/psx_syscall.h
	$(BUILD_FGREP) "#define LIBPSX_MINOR $(MINOR)" psx/psx_syscall.h
	@echo "Now validate that everything is checked in to a clean tree.."
	test -z "$$(git status --ignored -s)"
	@echo "All good!"

release: distclean
	cd .. && ln -s libcap libcap-$(VERSION).$(MINOR) && tar cvf libcap-$(VERSION).$(MINOR).tar --exclude patches libcap-$(VERSION).$(MINOR)/* && rm libcap-$(VERSION).$(MINOR)

ktest: all
	$(MAKE) -C kdebug test

distcheck: distclean
	./distcheck.sh
	$(MAKE) DYNAMIC=no COPTS="-D_FORTIFY_SOURCE=2 -O1 -g" clean test
	$(MAKE) DYNAMIC=yes clean all test sudotest
	$(MAKE) DYNAMIC=no COPTS="-O2 -std=c89" clean all test sudotest
	$(MAKE) PAM_CAP=no CC=musl-gcc clean all test sudotest
	$(MAKE) CC=clang clean all test sudotest
	$(MAKE) clean all test sudotest
	$(MAKE) distclean

morgangodoc:
	@echo "Now the release is made, you may want to hurry go.dev up by"
	@echo "pressing the request button on this page:"
	@echo
	@echo "  https://pkg.go.dev/kernel.org/pub/linux/libs/security/libcap/cap@v$(GOMAJOR).$(VERSION).$(MINOR)"
	@echo
	@echo "This will cause a go.dev documentation update more quickly."

morganrelease: distcheck
	@echo "sign the main library tag three times: legacy DSA key; newer RSA (kernel.org automation) key; official ed25519 key"
	git tag -u 0D23D34C577B08C4082CFD76430C5CFF993116B1 -s sig-libcap-$(VERSION).$(MINOR) -m "official tag for libcap-$(VERSION).$(MINOR)"
	git tag -u AF7402BC38CC10E6885C1FCA421784ABD41A6DF2 -s libcap-$(VERSION).$(MINOR) -m "legacy tag for libcap-$(VERSION).$(MINOR)"
	git tag -u 38A644698C69787344E954CE29EE848AE2CCF3F4 -s libcap-korg-$(VERSION).$(MINOR) -m "kernel.org automation tag for libcap-$(VERSION).$(MINOR)"
	@echo "The following are for the Go module tracking (the stylized tag names have semantic meaning)."
	git tag -u 0D23D34C577B08C4082CFD76430C5CFF993116B1 -s v$(GOMAJOR).$(VERSION).$(MINOR) -m "version tag for the 'libcap' Go base directory associated with libcap-$(VERSION).$(MINOR)"
	git tag -u 0D23D34C577B08C4082CFD76430C5CFF993116B1 -s psx/v$(GOMAJOR).$(VERSION).$(MINOR) -m "stable version tag for the 'psx' Go package associated with libcap-$(VERSION).$(MINOR)"
	git tag -u 0D23D34C577B08C4082CFD76430C5CFF993116B1 -s cap/v$(GOMAJOR).$(VERSION).$(MINOR) -m "stable version tag for the 'cap' Go package associated with libcap-$(VERSION).$(MINOR)"
	$(MAKE) release
	@echo "sign the tar file using korg key - so it can be uploaded to kernel.org"
	cd .. && gpg -sba -u 38A644698C69787344E954CE29EE848AE2CCF3F4 libcap-$(VERSION).$(MINOR).tar
	$(MAKE) morgangodoc

=== contrib/Makefile ===
.PHONY: all clean
all clean:
	for x in bug* ; do $(MAKE) -C $$x $@ || exit 1 ; done

=== progs/Makefile ===

topdir=$(shell pwd)/..
include $(topdir)/Make.Rules
#
# Programs: all of the examples that we will compile
#
PROGS=getpcaps getcap setcap

BUILD=$(PROGS)

all: $(BUILD) capsh

ifeq ($(DYNAMIC),yes)
LDPATH = LD_LIBRARY_PATH=../libcap
DEPS = ../libcap/libcap.so
else
ifeq ($(LIBCSTATIC),yes)
LDFLAGS = --static
DEPS = ../libcap/libcap.a
else
# For this build variant override the LDFLAGS to link statically from
# libraries within the build tree. If you never want this, use make
# DYNAMIC=yes . Note, we can't reliably link statically against glibc
# becasuse of https://sourceware.org/bugzilla/show_bug.cgi?id=12491 .
LDFLAGS = -Wl,-Bstatic
LDFLAGS_SUFFIX = -Wl,-Bdynamic
DEPS = ../libcap/libcap.a
endif
endif

../libcap/libcap.a:
	$(MAKE) -C ../libcap libcap.a

../libcap/libcap.so:
	$(MAKE) -C ../libcap libcap.so

$(BUILD): %: %.o $(DEPS)
	$(CC) $(CFLAGS) $(LDFLAGS) $< $(LIBCAPLIB) $(LDFLAGS_SUFFIX) -o $@

%.o: %.c $(INCS)
	$(CC) $(CFLAGS) $(CPPFLAGS) -c $< -o $@

install: all
	mkdir -p -m 0755 $(FAKEROOT)$(SBINDIR)
	for p in $(PROGS) capsh ; do \
		install -m 0755 $$p $(FAKEROOT)$(SBINDIR) ; \
	done
ifeq ($(RAISE_SETFCAP),yes)
	$(FAKEROOT)$(SBINDIR)/setcap cap_setfcap=i $(FAKEROOT)$(SBINDIR)/setcap
endif

test:
	@echo "no program tests without privilege, try 'make sudotest'"

capshdoc.c.cf: capshdoc.c ./mkcapshdoc.sh
	./mkcapshdoc.sh > $@
	diff -u capshdoc.c $@ || (rm $@ ; exit 1)

capsh: capsh.c capshdoc.c.cf capshdoc.h $(DEPS)
	$(CC) $(CFLAGS) $(CPPFLAGS) $(CAPSH_SHELL) $(LDFLAGS) $< capshdoc.c $(LIBCAPLIB) $(LDFLAGS_SUFFIX) -o $@

# Statically linked with minimal linkage flags to enable running in a
# chroot and in other in-tree testing contexts.
tcapsh-static: capsh.c capshdoc.c.cf capshdoc.h $(DEPS)
	$(CC) $(CFLAGS) $(CPPFLAGS) $(CAPSH_SHELL) -o $@ $< capshdoc.c $(LIBCAPLIB) --static

uns_test: ../tests/uns_test.c
	$(MAKE) -C ../tests uns_test
	cp ../tests/uns_test .

sudotest: tcapsh-static uns_test capsh setcap getcap getpcaps tcapsh-static
	$(SUDO) $(LDPATH) ./quicktest.sh

clean:
	$(LOCALCLEAN)
	rm -f *.o $(BUILD) privileged ping hack.sh compare-cap uns_test
	rm -f capsh tcapsh* capshdoc.*.cf

=== contrib/bug400591/Makefile ===
all: bug

bug: bug.c ../../libcap Makefile
	$(MAKE) -C ../../libcap
	$(CC) $(CFLAGS) $(CPPFLAGS) -g -I../../libcap/include --static -o $@ $< -L../../libcap -lcap
	./bug

clean:
	rm -f bug.o bug

=== debian/changelog ===
libcap2 (1:2.75-7ubuntu2) questing; urgency=medium

  * Rebuild to include updated RISC-V base ISA RVA23

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Fri, 05 Sep 2025 15:29:30 +0000

libcap2 (1:2.75-7ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #2111776). Remaining changes:
    - Strip -Wl,-Bsymbolic-functions from LDFLAGS (LP: #2003892)
  * Dropped Changes:
    - d/t/upstream-root: Skip "uns_test" to fix autopkgtests on armhf.
      It's failing on armhf due to the version of the kernel we use in our
      infrastructure for for this architecture. Once we upgrade our hosts,
      this patch can be dropped. See LP: #2003892.

 -- Pragyansh Chaturvedi <pragyansh.chaturvedi@canonical.com>  Tue, 27 May 2025 12:56:51 +0530

libcap2 (1:2.75-7) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Move go dependencies to B-D-I. (Closes: #1103808)

 -- Christian Kastner <ckk@debian.org>  Mon, 21 Apr 2025 20:42:52 +0200

libcap2 (1:2.75-6) unstable; urgency=medium

  * Add cleaning for Golang build
  * Switch from chrpath to patchelf

 -- Christian Kastner <ckk@debian.org>  Fri, 11 Apr 2025 20:52:04 +0200

libcap2 (1:2.75-5) unstable; urgency=medium

  * Upload to unstable
  * Cherry-pick a signal handler API fix

 -- Christian Kastner <ckk@debian.org>  Wed, 09 Apr 2025 23:38:14 +0200

libcap2 (1:2.75-5~exp1) experimental; urgency=medium

  [ Simon Josefsson ]
  * Add Go package.

 -- Christian Kastner <ckk@debian.org>  Mon, 07 Apr 2025 13:14:39 +0200

libcap2 (1:2.75-4) unstable; urgency=medium

  * Upload to unstable.

 -- Christian Kastner <ckk@debian.org>  Tue, 25 Mar 2025 21:24:16 +0100

libcap2 (1:2.75-4~exp1) experimental; urgency=medium

  * Cherry-pick upstream patches attempting FTBFS fix on debian-ports
   - Add new symbol to symbols file
  * Re-enable executable library tests

 -- Christian Kastner <ckk@debian.org>  Sun, 23 Mar 2025 19:30:49 +0100

libcap2 (1:2.75-3) unstable; urgency=medium

  * Temporarily skip tests on mips64el, powerpc.
    Affected by #1089636 in glibc.

 -- Christian Kastner <ckk@debian.org>  Thu, 20 Mar 2025 23:46:07 +0100

libcap2 (1:2.75-2) unstable; urgency=medium

  * Skip executable shared library test.
    This segfaults on mips64el and powerpc. Since this functionality is not
    enabled anyway, skip the test for now until the root cause has been
    identified and resolved. (Closes: #1089636)

 -- Christian Kastner <ckk@debian.org>  Thu, 13 Mar 2025 15:36:17 +0100

libcap2 (1:2.75-1) unstable; urgency=medium

  [ Otto Kekäläinen ]
  * Salsa CI: Test for missing Breaks and Replaces.

  [ Christian Kastner ]
  * New upstream version 2.75
  * Refresh patches
  * gbp.conf Add upstream-signatures=on

 -- Christian Kastner <ckk@debian.org>  Fri, 07 Mar 2025 10:05:09 +0100

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,19 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Christian Kastner <ckk@debian.org>
-Build-Depends: chrpath,
+Build-Depends: patchelf,
                debhelper-compat (= 13),
                gperf (>= 3.1),
                indent,
                libpam0g-dev,
+Build-Depends-Indep: dh-golang,
+                     golang-any,
 Rules-Requires-Root: no
 Standards-Version: 4.7.0
 Homepage: https://sites.google.com/site/fullycapable/
 Vcs-Git: https://salsa.debian.org/debian/libcap2.git
 Vcs-Browser: https://salsa.debian.org/debian/libcap2
+XS-Go-Import-Path: kernel.org/pub/linux/libs/security/libcap
 
 Package: libcap2-bin
 Section: utils
@@ -83,3 +86,16 @@
  powerful root privilege into a set of distinct privileges.
  .
  This is a minimal version, only for use in the installation system.
+
+Package: golang-kernel-pub-linux-libs-security-libcap-dev
+Architecture: all
+Multi-Arch: foreign
+Depends:
+ ${misc:Depends},
+Description: POSIX 1003.1e capabilities (Go library)
+ Libcap implements the user-space interfaces to the POSIX 1003.1e capabilities
+ available in Linux kernels. These capabilities are a partitioning of the all
+ powerful root privilege into a set of distinct privileges.
+ .
+ This package provides the kernel.org/pub/linux/libs/security/libcap/cap and
+ kernel.org/pub/linux/libs/security/libcap/psx Go libraries.

=== debian/rules ===
--- 
+++ 
@@ -38,6 +38,12 @@
 
 override_dh_auto_clean:
 	dh_auto_clean -- $(MAKE_ASSIGNMENTS)
+	# The Golang build system does not appear to fully honor -B, so we need
+	# two cleans
+	set -e; if test -d _build; then \
+		dh_auto_clean -B_build -O--buildsystem=golang; \
+		dh_auto_clean O--buildsystem=golang; \
+	fi
 	# Undo change of lookup (see override_dh_auto_build)
 	sed -i -e 's,\./tcapsh-static,../progs/tcapsh-static,g' tests/libcap_launch_test.c
 
@@ -81,7 +87,7 @@
 	# (avoiding it and going through LD_LIBRARY_PATH didn't work in all
 	# cases)
 	# List is identical to build above, minus noop (no RPATH)
-	cd tests && chrpath -d \
+	cd tests && patchelf --remove-rpath \
 		psx_test \
 		libcap_psx_test \
 		uns_test \
@@ -104,3 +110,16 @@
 	dh_makeshlibs -V'libcap2 (>= $(SHLIBS_MINVER))' -plibcap2 \
 		--add-udeb=libcap2-udeb -- -c4
 	dh_makeshlibs --remaining-packages -- -c4
+
+export DH_GOLANG_BUILDPKG := \
+	kernel.org/pub/linux/libs/security/libcap/cap \
+	kernel.org/pub/linux/libs/security/libcap/psx
+
+execute_after_dh_auto_configure-indep:
+	dh_auto_configure -B_build -O--buildsystem=golang
+
+execute_after_dh_auto_install-indep:
+	dh_auto_install -B_build -O--buildsystem=golang
+
+execute_after_dh_auto_build-indep:
+	dh_auto_build -B_build -O--buildsystem=golang

=== debian/watch ===
version=4

opts="pgpsigurlmangle=s%\.xz$%.sign%,decompress" \
https://www.kernel.org/pub/linux/libs/security/linux-privs/libcap2/libcap-(.+).tar.xz
